﻿Imports System
Imports ClouReaderAPI

Public Class Form1 : Implements ClouReaderAPI.ClouInterface.IAsynchronousMessage
    Public Delegate Sub WriteDebug(ByVal msg As String)
    Private IsWriteDebug As Boolean = True
    Private Const MAX_DEBUG_MESSAGE As Integer = 1000
    Private nowDebugMessageCount As Integer = 0
    Dim ConnectID As String
    Dim sReturnString As String
    Public Sub GPIControlMsg(ByVal gpiIndex As Integer, ByVal gpiState As Integer, ByVal startOrStop As Integer) Implements ClouReaderAPI.ClouInterface.IAsynchronousMessage.GPIControlMsg
    End Sub

    Public Sub OutPutTags(ByVal tag As ClouReaderAPI.Models.Tag_Model) Implements ClouReaderAPI.ClouInterface.IAsynchronousMessage.OutPutTags
        WriteMessageToTexBox("Antenna" + CStr(tag.ANT_NUM) + "--EPC:" + CStr(tag.EPC) + "  TID:" + CStr(tag.TID))
    End Sub

    Public Sub OutPutTagsOver() Implements ClouReaderAPI.ClouInterface.IAsynchronousMessage.OutPutTagsOver

    End Sub

    Public Sub PortClosing(ByVal connID As String) Implements ClouReaderAPI.ClouInterface.IAsynchronousMessage.PortClosing

    End Sub

    Public Sub PortConneting(ByVal connID As String) Implements ClouReaderAPI.ClouInterface.IAsynchronousMessage.PortConneting

    End Sub

    Public Sub WriteDebugMsg(ByVal msg As String) Implements ClouReaderAPI.ClouInterface.IAsynchronousMessage.WriteDebugMsg
        WriteMessageToTexBox(msg)
    End Sub

    Public Sub WriteLog(ByVal msg As String) Implements ClouReaderAPI.ClouInterface.IAsynchronousMessage.WriteLog

    End Sub

    Private Sub cb_ConnectType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_ConnectType.SelectedIndexChanged
        If (cb_ConnectType.SelectedIndex = 0) Then
            tb_ConnParam.Text = "COM1:115200"
        ElseIf (cb_ConnectType.SelectedIndex = 1) Then
            tb_ConnParam.Text = "192.168.1.116:9090"
        ElseIf (cb_ConnectType.SelectedIndex = 2) Then
            tb_ConnParam.Text = "1:COM1:115200"
        End If
    End Sub

    Public Function ConnectReader() As Boolean                   'Connect reader
        Dim isConnect As Boolean                                 ' Verify that the connection is successful

        If (cb_ConnectType.SelectedIndex = 0) Then
            isConnect = CLReader.CreateSerialConn(tb_ConnParam.Text.Trim(), Me)       ' Create serial connection
        ElseIf (cb_ConnectType.SelectedIndex = 1) Then
            isConnect = CLReader.CreateTcpConn(tb_ConnParam.Text.Trim(), Me)          ' Create TCP connection
        ElseIf (cb_ConnectType.SelectedIndex = 2) Then
            isConnect = CLReader.Create485Conn(tb_ConnParam.Text.Trim(), Me)          ' Create 485 connection
        End If
        If (isConnect) Then                                                           '  Connection successful
            ConnectID = tb_ConnParam.Text.Trim()
            isConnect = True
        Else
            isConnect = False                                                        ' The specific cause of the failure of the connection,  in IAsynchronousMessage WriteDebugMsg (MSG); method callback
        End If
        Return isConnect

    End Function
    Private Sub CloseConnect()
        If ConnectID <> "" Then
            CLReader.RFID_OPTION.StopReader(ConnectID)             'Stop reading
            CLReader.CloseConn(ConnectID)                         ' Close connection
        End If
    End Sub
    Private Sub btn_Conncet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Conncet.Click
        If btn_Conncet.Tag = 0 Then
            If (ConnectReader()) Then                                ' Connect reader
                btn_Conncet.Tag = "1"
                btn_Conncet.Text = "Disconnect"
                btn_ReadEPC.Enabled = True
                btn_ReadTID.Enabled = True
                btn_Stop.Enabled = True
            Else
                MessageBox.Show("Connect reader failed!")
            End If
        Else
            CloseConnect()
            btn_Conncet.Tag = "0"
            btn_Conncet.Text = "Connect"
            btn_ReadEPC.Enabled = False
            btn_ReadTID.Enabled = False
            btn_Stop.Enabled = False
        End If
    End Sub

   

    ' Get reading parameters
    Public Function GetReadTagParam(ByVal varParam As String) As String
        Dim rt As String = ""
        Dim antNUM As Int32 = 0
        Dim singleOrWhile As Int32 = -1
        ' Gets required parameters: antenna number & single read/cycle read
        For Each item As Object In gb_ReadControl.Controls
            Dim control As CheckBox = TryCast(item, CheckBox)
            If control IsNot Nothing AndAlso control.Checked Then
                antNUM += Int32.Parse(control.Tag.ToString())
            End If
        Next
        For Each item As Object In gb_ReadType.Controls
            Dim control As RadioButton = TryCast(item, RadioButton)
            If control IsNot Nothing AndAlso control.Checked Then
                singleOrWhile = [Byte].Parse(control.Tag.ToString())
            End If
        Next
        rt += CStr(antNUM) + "|" + CStr(singleOrWhile) + "|"
        If Not [String].IsNullOrEmpty(varParam) Then
            rt += varParam
        End If
        rt = rt.TrimEnd("|"c)
        Return rt
    End Function

    Public Sub WriteMessageToTexBox(ByVal msg As String)
        If Not IsWriteDebug Then
            Return
        End If

        If tb_DebugMsg.InvokeRequired Then
            tb_DebugMsg.BeginInvoke(New WriteDebug(AddressOf WriteDebugMsg), msg)
            Return
        End If
        If nowDebugMessageCount >= 1000 Then
            nowDebugMessageCount = 0
            tb_DebugMsg.Clear()
        End If
        tb_DebugMsg.AppendText(msg + Environment.NewLine)
        System.Math.Max(System.Threading.Interlocked.Increment(nowDebugMessageCount), nowDebugMessageCount - 1)
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        cb_ConnectType.SelectedIndex = 0
        WriteMessageToTexBox("If you have any questions or Suggestions about API, please contact Hopeland")
        WriteMessageToTexBox("")
        WriteMessageToTexBox("Tips:")
        WriteMessageToTexBox("1. This example only demonstrates how to read and receive tag data through the API. If you need to configure the read parameters, please use the RFID reader demo software.")
        WriteMessageToTexBox(" 2. Select the corresponding connection mode -- connect-- reading EPC or TID")
        WriteMessageToTexBox("")
    End Sub
    Private Sub btn_ReadEPC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ReadEPC.Click
        CLReader.RFID_OPTION.StopReader(ConnectID)                                       ' stop first
        sReturnString = CLReader.RFID_OPTION.GetEPC(ConnectID, GetReadTagParam(""))      ' read
    End Sub
    Private Sub btn_ReadTID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ReadTID.Click
        ClouReaderAPI.CLReader.RFID_OPTION.StopReader(ConnectID)              ' stop first
        sReturnString = CLReader.RFID_OPTION.GetEPC(ConnectID, GetReadTagParam("2,0006"))
    End Sub

    Private Sub btn_Stop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Stop.Click
        ClouReaderAPI.CLReader.RFID_OPTION.StopReader(ConnectID)
    End Sub

    Private Sub gb_Message_Enter(sender As Object, e As EventArgs) Handles gb_Message.Enter

    End Sub
End Class
